#ifndef SPACEVM_DPI_XDP_HELPER_H
#define SPACEVM_DPI_XDP_HELPER_H

#define RING_BUFFER_INIT(NAME_, INDEX_) \
    struct { \
        __uint(type, BPF_MAP_TYPE_RINGBUF); \
        __uint(max_entries, 2048 * 4096); \
    } NAME_##_##INDEX_ SEC(".maps");
#define BRANCH(NAME_, INDEX_) \
    case INDEX_: \
        packet = bpf_ringbuf_reserve(&NAME_##_##INDEX_, 2048, 0); \
        if (!packet) { \
            ret = -1; \
            break; \
        } \
        if (bpf_probe_read_kernel(packet, 2, (void *) &data_size) || \
            bpf_probe_read_kernel(packet + 2, min(data_size, 2046), (void *) (long) ctx->data)) { \
                bpf_ringbuf_discard(packet, 0); \
                ret = -1; \
                break; \
        } \
        bpf_ringbuf_submit(packet, 0); \
        break;

#define FOREACH(FN_, NAME_, N_) FOREACH_##N_(FN_, NAME_)
#define FOREACH_1(FN_, NAME_) FN_(NAME_, 0)
#define FOREACH_2(FN_, NAME_) FOREACH_1(FN_, NAME_) FN_(NAME_, 1)
#define FOREACH_3(FN_, NAME_) FOREACH_2(FN_, NAME_) FN_(NAME_, 2)
#define FOREACH_4(FN_, NAME_) FOREACH_3(FN_, NAME_) FN_(NAME_, 3)
#define FOREACH_5(FN_, NAME_) FOREACH_4(FN_, NAME_) FN_(NAME_, 4)
#define FOREACH_6(FN_, NAME_) FOREACH_5(FN_, NAME_) FN_(NAME_, 5)
#define FOREACH_7(FN_, NAME_) FOREACH_6(FN_, NAME_) FN_(NAME_, 6)
#define FOREACH_8(FN_, NAME_) FOREACH_7(FN_, NAME_) FN_(NAME_, 7)
#define FOREACH_9(FN_, NAME_) FOREACH_8(FN_, NAME_) FN_(NAME_, 8)
#define FOREACH_10(FN_, NAME_) FOREACH_9(FN_, NAME_) FN_(NAME_, 9)
#define FOREACH_11(FN_, NAME_) FOREACH_10(FN_, NAME_) FN_(NAME_, 10)
#define FOREACH_12(FN_, NAME_) FOREACH_11(FN_, NAME_) FN_(NAME_, 11)
#define FOREACH_13(FN_, NAME_) FOREACH_12(FN_, NAME_) FN_(NAME_, 12)
#define FOREACH_14(FN_, NAME_) FOREACH_13(FN_, NAME_) FN_(NAME_, 13)
#define FOREACH_15(FN_, NAME_) FOREACH_14(FN_, NAME_) FN_(NAME_, 14)
#define FOREACH_16(FN_, NAME_) FOREACH_15(FN_, NAME_) FN_(NAME_, 15)
#define FOREACH_17(FN_, NAME_) FOREACH_16(FN_, NAME_) FN_(NAME_, 16)
#define FOREACH_18(FN_, NAME_) FOREACH_17(FN_, NAME_) FN_(NAME_, 17)
#define FOREACH_19(FN_, NAME_) FOREACH_18(FN_, NAME_) FN_(NAME_, 18)
#define FOREACH_20(FN_, NAME_) FOREACH_19(FN_, NAME_) FN_(NAME_, 19)
#define FOREACH_21(FN_, NAME_) FOREACH_20(FN_, NAME_) FN_(NAME_, 20)
#define FOREACH_22(FN_, NAME_) FOREACH_21(FN_, NAME_) FN_(NAME_, 21)
#define FOREACH_23(FN_, NAME_) FOREACH_22(FN_, NAME_) FN_(NAME_, 22)
#define FOREACH_24(FN_, NAME_) FOREACH_23(FN_, NAME_) FN_(NAME_, 23)
#define FOREACH_25(FN_, NAME_) FOREACH_24(FN_, NAME_) FN_(NAME_, 24)
#define FOREACH_26(FN_, NAME_) FOREACH_25(FN_, NAME_) FN_(NAME_, 25)
#define FOREACH_27(FN_, NAME_) FOREACH_26(FN_, NAME_) FN_(NAME_, 26)
#define FOREACH_28(FN_, NAME_) FOREACH_27(FN_, NAME_) FN_(NAME_, 27)
#define FOREACH_29(FN_, NAME_) FOREACH_28(FN_, NAME_) FN_(NAME_, 28)
#define FOREACH_30(FN_, NAME_) FOREACH_29(FN_, NAME_) FN_(NAME_, 29)
#define FOREACH_31(FN_, NAME_) FOREACH_30(FN_, NAME_) FN_(NAME_, 30)
#define FOREACH_32(FN_, NAME_) FOREACH_31(FN_, NAME_) FN_(NAME_, 31)
#define FOREACH_33(FN_, NAME_) FOREACH_32(FN_, NAME_) FN_(NAME_, 32)
#define FOREACH_34(FN_, NAME_) FOREACH_33(FN_, NAME_) FN_(NAME_, 33)
#define FOREACH_35(FN_, NAME_) FOREACH_34(FN_, NAME_) FN_(NAME_, 34)
#define FOREACH_36(FN_, NAME_) FOREACH_35(FN_, NAME_) FN_(NAME_, 35)
#define FOREACH_37(FN_, NAME_) FOREACH_36(FN_, NAME_) FN_(NAME_, 36)
#define FOREACH_38(FN_, NAME_) FOREACH_37(FN_, NAME_) FN_(NAME_, 37)
#define FOREACH_39(FN_, NAME_) FOREACH_38(FN_, NAME_) FN_(NAME_, 38)
#define FOREACH_40(FN_, NAME_) FOREACH_39(FN_, NAME_) FN_(NAME_, 39)
#define FOREACH_41(FN_, NAME_) FOREACH_40(FN_, NAME_) FN_(NAME_, 40)
#define FOREACH_42(FN_, NAME_) FOREACH_41(FN_, NAME_) FN_(NAME_, 41)
#define FOREACH_43(FN_, NAME_) FOREACH_42(FN_, NAME_) FN_(NAME_, 42)
#define FOREACH_44(FN_, NAME_) FOREACH_43(FN_, NAME_) FN_(NAME_, 43)
#define FOREACH_45(FN_, NAME_) FOREACH_44(FN_, NAME_) FN_(NAME_, 44)
#define FOREACH_46(FN_, NAME_) FOREACH_45(FN_, NAME_) FN_(NAME_, 45)
#define FOREACH_47(FN_, NAME_) FOREACH_46(FN_, NAME_) FN_(NAME_, 46)
#define FOREACH_48(FN_, NAME_) FOREACH_47(FN_, NAME_) FN_(NAME_, 47)
#define FOREACH_49(FN_, NAME_) FOREACH_48(FN_, NAME_) FN_(NAME_, 48)
#define FOREACH_50(FN_, NAME_) FOREACH_49(FN_, NAME_) FN_(NAME_, 49)
#define FOREACH_51(FN_, NAME_) FOREACH_50(FN_, NAME_) FN_(NAME_, 50)
#define FOREACH_52(FN_, NAME_) FOREACH_51(FN_, NAME_) FN_(NAME_, 51)
#define FOREACH_53(FN_, NAME_) FOREACH_52(FN_, NAME_) FN_(NAME_, 52)
#define FOREACH_54(FN_, NAME_) FOREACH_53(FN_, NAME_) FN_(NAME_, 53)
#define FOREACH_55(FN_, NAME_) FOREACH_54(FN_, NAME_) FN_(NAME_, 54)
#define FOREACH_56(FN_, NAME_) FOREACH_55(FN_, NAME_) FN_(NAME_, 55)
#define FOREACH_57(FN_, NAME_) FOREACH_56(FN_, NAME_) FN_(NAME_, 56)
#define FOREACH_58(FN_, NAME_) FOREACH_57(FN_, NAME_) FN_(NAME_, 57)
#define FOREACH_59(FN_, NAME_) FOREACH_58(FN_, NAME_) FN_(NAME_, 58)
#define FOREACH_60(FN_, NAME_) FOREACH_59(FN_, NAME_) FN_(NAME_, 59)
#define FOREACH_61(FN_, NAME_) FOREACH_60(FN_, NAME_) FN_(NAME_, 60)
#define FOREACH_62(FN_, NAME_) FOREACH_61(FN_, NAME_) FN_(NAME_, 61)
#define FOREACH_63(FN_, NAME_) FOREACH_62(FN_, NAME_) FN_(NAME_, 62)
#define FOREACH_64(FN_, NAME_) FOREACH_63(FN_, NAME_) FN_(NAME_, 63)
#define FOREACH_65(FN_, NAME_) FOREACH_64(FN_, NAME_) FN_(NAME_, 64)
#define FOREACH_66(FN_, NAME_) FOREACH_65(FN_, NAME_) FN_(NAME_, 65)
#define FOREACH_67(FN_, NAME_) FOREACH_66(FN_, NAME_) FN_(NAME_, 66)
#define FOREACH_68(FN_, NAME_) FOREACH_67(FN_, NAME_) FN_(NAME_, 67)
#define FOREACH_69(FN_, NAME_) FOREACH_68(FN_, NAME_) FN_(NAME_, 68)
#define FOREACH_70(FN_, NAME_) FOREACH_69(FN_, NAME_) FN_(NAME_, 69)
#define FOREACH_71(FN_, NAME_) FOREACH_70(FN_, NAME_) FN_(NAME_, 70)
#define FOREACH_72(FN_, NAME_) FOREACH_71(FN_, NAME_) FN_(NAME_, 71)
#define FOREACH_73(FN_, NAME_) FOREACH_72(FN_, NAME_) FN_(NAME_, 72)
#define FOREACH_74(FN_, NAME_) FOREACH_73(FN_, NAME_) FN_(NAME_, 73)
#define FOREACH_75(FN_, NAME_) FOREACH_74(FN_, NAME_) FN_(NAME_, 74)
#define FOREACH_76(FN_, NAME_) FOREACH_75(FN_, NAME_) FN_(NAME_, 75)
#define FOREACH_77(FN_, NAME_) FOREACH_76(FN_, NAME_) FN_(NAME_, 76)
#define FOREACH_78(FN_, NAME_) FOREACH_77(FN_, NAME_) FN_(NAME_, 77)
#define FOREACH_79(FN_, NAME_) FOREACH_78(FN_, NAME_) FN_(NAME_, 78)
#define FOREACH_80(FN_, NAME_) FOREACH_79(FN_, NAME_) FN_(NAME_, 79)
#define FOREACH_81(FN_, NAME_) FOREACH_80(FN_, NAME_) FN_(NAME_, 80)
#define FOREACH_82(FN_, NAME_) FOREACH_81(FN_, NAME_) FN_(NAME_, 81)
#define FOREACH_83(FN_, NAME_) FOREACH_82(FN_, NAME_) FN_(NAME_, 82)
#define FOREACH_84(FN_, NAME_) FOREACH_83(FN_, NAME_) FN_(NAME_, 83)
#define FOREACH_85(FN_, NAME_) FOREACH_84(FN_, NAME_) FN_(NAME_, 84)
#define FOREACH_86(FN_, NAME_) FOREACH_85(FN_, NAME_) FN_(NAME_, 85)
#define FOREACH_87(FN_, NAME_) FOREACH_86(FN_, NAME_) FN_(NAME_, 86)
#define FOREACH_88(FN_, NAME_) FOREACH_87(FN_, NAME_) FN_(NAME_, 87)
#define FOREACH_89(FN_, NAME_) FOREACH_88(FN_, NAME_) FN_(NAME_, 88)
#define FOREACH_90(FN_, NAME_) FOREACH_89(FN_, NAME_) FN_(NAME_, 89)
#define FOREACH_91(FN_, NAME_) FOREACH_90(FN_, NAME_) FN_(NAME_, 90)
#define FOREACH_92(FN_, NAME_) FOREACH_91(FN_, NAME_) FN_(NAME_, 91)
#define FOREACH_93(FN_, NAME_) FOREACH_92(FN_, NAME_) FN_(NAME_, 92)
#define FOREACH_94(FN_, NAME_) FOREACH_93(FN_, NAME_) FN_(NAME_, 93)
#define FOREACH_95(FN_, NAME_) FOREACH_94(FN_, NAME_) FN_(NAME_, 94)
#define FOREACH_96(FN_, NAME_) FOREACH_95(FN_, NAME_) FN_(NAME_, 95)
#define FOREACH_97(FN_, NAME_) FOREACH_96(FN_, NAME_) FN_(NAME_, 96)
#define FOREACH_98(FN_, NAME_) FOREACH_97(FN_, NAME_) FN_(NAME_, 97)
#define FOREACH_99(FN_, NAME_) FOREACH_98(FN_, NAME_) FN_(NAME_, 98)
#define FOREACH_100(FN_, NAME_) FOREACH_99(FN_, NAME_) FN_(NAME_, 99)
#define FOREACH_101(FN_, NAME_) FOREACH_100(FN_, NAME_) FN_(NAME_, 100)
#define FOREACH_102(FN_, NAME_) FOREACH_101(FN_, NAME_) FN_(NAME_, 101)
#define FOREACH_103(FN_, NAME_) FOREACH_102(FN_, NAME_) FN_(NAME_, 102)
#define FOREACH_104(FN_, NAME_) FOREACH_103(FN_, NAME_) FN_(NAME_, 103)
#define FOREACH_105(FN_, NAME_) FOREACH_104(FN_, NAME_) FN_(NAME_, 104)
#define FOREACH_106(FN_, NAME_) FOREACH_105(FN_, NAME_) FN_(NAME_, 105)
#define FOREACH_107(FN_, NAME_) FOREACH_106(FN_, NAME_) FN_(NAME_, 106)
#define FOREACH_108(FN_, NAME_) FOREACH_107(FN_, NAME_) FN_(NAME_, 107)
#define FOREACH_109(FN_, NAME_) FOREACH_108(FN_, NAME_) FN_(NAME_, 108)
#define FOREACH_110(FN_, NAME_) FOREACH_109(FN_, NAME_) FN_(NAME_, 109)
#define FOREACH_111(FN_, NAME_) FOREACH_110(FN_, NAME_) FN_(NAME_, 110)
#define FOREACH_112(FN_, NAME_) FOREACH_111(FN_, NAME_) FN_(NAME_, 111)
#define FOREACH_113(FN_, NAME_) FOREACH_112(FN_, NAME_) FN_(NAME_, 112)
#define FOREACH_114(FN_, NAME_) FOREACH_113(FN_, NAME_) FN_(NAME_, 113)
#define FOREACH_115(FN_, NAME_) FOREACH_114(FN_, NAME_) FN_(NAME_, 114)
#define FOREACH_116(FN_, NAME_) FOREACH_115(FN_, NAME_) FN_(NAME_, 115)
#define FOREACH_117(FN_, NAME_) FOREACH_116(FN_, NAME_) FN_(NAME_, 116)
#define FOREACH_118(FN_, NAME_) FOREACH_117(FN_, NAME_) FN_(NAME_, 117)
#define FOREACH_119(FN_, NAME_) FOREACH_118(FN_, NAME_) FN_(NAME_, 118)
#define FOREACH_120(FN_, NAME_) FOREACH_119(FN_, NAME_) FN_(NAME_, 119)
#define FOREACH_121(FN_, NAME_) FOREACH_120(FN_, NAME_) FN_(NAME_, 120)
#define FOREACH_122(FN_, NAME_) FOREACH_121(FN_, NAME_) FN_(NAME_, 121)
#define FOREACH_123(FN_, NAME_) FOREACH_122(FN_, NAME_) FN_(NAME_, 122)
#define FOREACH_124(FN_, NAME_) FOREACH_123(FN_, NAME_) FN_(NAME_, 123)
#define FOREACH_125(FN_, NAME_) FOREACH_124(FN_, NAME_) FN_(NAME_, 124)
#define FOREACH_126(FN_, NAME_) FOREACH_125(FN_, NAME_) FN_(NAME_, 125)
#define FOREACH_127(FN_, NAME_) FOREACH_126(FN_, NAME_) FN_(NAME_, 126)
#define FOREACH_128(FN_, NAME_) FOREACH_127(FN_, NAME_) FN_(NAME_, 127)

#endif //SPACEVM_DPI_XDP_HELPER_H
